﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Runtime.InteropServices; // needed for DllImport
using System.Text; // needed for StringBuilder Class
using System.IO;

// Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
// or the page: 
// http://www.cognaxon.com/index.php?page=wsqlib_NETnotes
// FAQ (Frequently Asked Questions)
// for .NET developers on using WSQ image library


namespace wsq_demo
{
    public partial class Form1 : Form
    {

        private WSQImageLibraryNativeMethods WSQ_library_native_methods;

        private IntPtr bp;
        private System.Drawing.Bitmap b;
        private byte[] input_data_stream;
        private byte[] input_data_stream2;
        private byte[] output_data_stream;
        private byte[] output_data_stream2;
        private Int64 width;
        private Int64 height;
        private Int64 ppi;
        private double bitrate;
        private String comment_text;
		private UTF8Encoding utf8 = new UTF8Encoding();
		

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            comment_text = String.Empty; //need to initialize comment_text in order to avoid crashing

            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            WSQ_library_native_methods = new WSQImageLibraryNativeMethods();
        }




        // To call functions from WSQ_library64.dll
		// you can use the methods from wrapper class WSQImageLibraryNativeMethods
		// or you can use function prototypes provided below 

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr CreateBMPFromFile(byte[] filename);

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SaveBMPToFile(IntPtr hBitmap, byte[] filename, Int64 filetype);

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void RegisterWSQ();

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void SetShowFilePropertiesDialog(Int64 file_properties_dialog);

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void ShowFileConverter();

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern IntPtr ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library64.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, byte[] filename);




        private void buttonOpen_Click(object sender, EventArgs e)
        {

            OpenFileDialog ofd = new OpenFileDialog();


            ofd.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;" +
"*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.pbm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|" +
"FBI's Wavelet Scalar Quantization (*.wsq)|*.wsq|" +
"Windows Bitmap Graphics (*.bmp)|*.bmp|" +
"Macintosh Tagged Information File Format images (*.tiff)|*.tiff|" +
"PC Tagged Information File Format images (*.tif)|*.tif|" +
"Joint Photographic Experts Group images (*.jpg)|*.jpg|" +
"Joint Photographic Experts Group images (*.jpeg)|*.jpeg|" +
"JPEG2000 Part 1 images (*.jp2)|*.jp2|" +
"JPEG2000 Code Stream images (*.jpc)|*.jpc|" +
"Portable Network Graphics images (*.png)|*.png|" +
"Compuserve Graphic Interchange Format images (*.gif)|*.gif|" +
"Truevision Targa Graphic images (*.tga )|*.tga|" +
"ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|" +
"Portable Pixel Map Images (*.ppm)|*.ppm|" +
"Portable Gray Map Images (*.pgm)|*.pgm|" +
"Portable Bitmap Images (*.pbm)|*.pbm|" +
"Windows Icons (*.ico)|*.ico|" +
"Windows Metafiles (*.wmf)|*.wmf|" +
"Wireless Bitmap File Format (*.wbmp)|*.wbmp|" +
"SKA Format images (*.ska)|*.ska|" +
"Muti-image Network Graphic Animation (*.mng)|*.mng|" +
"PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|" +
"Sun Graphic (*.ras)|*.ras|" +
"RAW Graphic (*.raw)|*.raw";


            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //bp = CreateBMPFromFile(utf8.GetBytes(ofd.FileName));
            bp = WSQ_library_native_methods.pCreateBMPFromFile(ofd.FileName);
            b = Image.FromHbitmap(bp);
            picture.Image = b;

            Int32 h = picture.Image.Height;
            Int32 w = picture.Image.Width;
            picture.SetBounds(0, 0, w, h);

            buttonSave.Enabled = true;

        }

        private void buttonSave_Click(object sender, EventArgs e)
        {


			SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "WSQ Files (*.wsq)|*.wsq|" + // 1
"Windows BMP (*.bmp)|*.bmp|" + // 2
"TIFF Files (*.tif)|*.tif|" + // 3
"PNG Files (*.png)|*.png|" + // 4
"JPEG Files (*.jpg)|*.jpg|" + // 5
"Targa Files (*.tga)|*.tga|" + // 6
"SGI Files (*.rgb)|*.rgb|" + // 7
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" + // 8
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" + // 9
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" + // 10
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" + // 11
"PPM - Portable Pixmap Format (*.ppm)|*.ppm|" + // 12
"GIF Files (*.gif)|*.gif|" + // 13
"PNM Files (*.pnm)|*.pnm|" + // 14
"RAS Files (*.ras)|*.ras|" + // 15
"MNG Files (*.mng)|*.mng|" + // 16
"PCX Files (*.pcx)|*.pcx"; // 17


            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //SetShowFilePropertiesDialog(1);
            WSQ_library_native_methods.pSetShowFilePropertiesDialog(1);

            Bitmap b;
            IntPtr bp;

            b = new Bitmap(picture.Image);
            bp = b.GetHbitmap();

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //SaveBMPToFile(bp, utf8.GetBytes(sfd.FileName), sfd.FilterIndex);
            WSQ_library_native_methods.pSaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);

        }


        private void buttonRegister_Click(object sender, EventArgs e)
        {


            // "RegisterWSQ64.exe" and "WSQ image library (for Windows 64-bit)" were compiled using Microsoft Visual C++ 2008 version compiler.
            // If it fails to run then you need to install “Microsoft Visual C++ 2008 Redistributable Package (x64)”.
            // The download link is:
            // https://www.microsoft.com/en-us/download/details.aspx?id=26368
            // Microsoft Visual C++ 2008 Redistributable Package (x64)

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //RegisterWSQ();
            WSQ_library_native_methods.pRegisterWSQ();

        }

        private void buttonWSQtoStream_Click(object sender, EventArgs e)
        {


            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            FileInfo fInfo = new FileInfo(ofd.FileName);
            long input_stream_length = fInfo.Length;
            FileStream fStream = new FileStream(ofd.FileName, FileMode.Open, FileAccess.Read);
            BinaryReader br = new BinaryReader(fStream);

            input_data_stream = br.ReadBytes((int)input_stream_length);

            WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, (Int64)input_stream_length,
                out output_data_stream, out width, out height, out ppi, out comment_text);

            //Converts WSQ compressed byte array into HBITMAP for showing on screen
            bp = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, (Int64)input_stream_length);
            b = Image.FromHbitmap(bp);
            picture.Image = b;

            Int32 h = picture.Image.Height;
            Int32 w = picture.Image.Width;
            picture.SetBounds(0, 0, w, h);

            Int64 output_data_stream_length = height * width;

            // Saves WSQ compressed byte array to an image file.
            //WSQ_library_native_methods.SaveWSQByteArrayToImageFile(input_data_stream, (Int64)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


            MessageBox.Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

            br.Close();
            fStream.Close();



            buttonStreamToWSQ.Enabled = true;

        }

        private void buttonStreamToWSQ_Click(object sender, EventArgs e)
        {



            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "WSQ Files (*.wsq)|*.wsq";
            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                return;
            }


            bitrate = 0.75;
            ppi = 500;
            //comment_text = "";
            comment_text = "Cognaxon";


            input_data_stream2 = new byte[width * height];
            Int64 row, row2, pixel_number, pixel_number2;

            // MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
            for (Int64 y = 0; y < height; y++)
            {
                row = width * y;
                row2 = width * (height - y - 1);
                for (Int64 x = 0; x < width; x++)
                {
                    pixel_number = row + x;
                    pixel_number2 = row2 + (width - x - 1);

                    input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
                }
            }


            Int64 compressedLength;
            WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, width, height,
                bitrate, ppi, comment_text, out output_data_stream2, out compressedLength);


            FileStream fStream = new FileStream(sfd.FileName, FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fStream);

            bw.Write(output_data_stream2);
            bw.Close();
            fStream.Close();
            MessageBox.Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");


        }
    }
}
